Index: pbx.c
===================================================================
RCS file: /usr/cvsroot/asterisk/pbx.c,v
retrieving revision 1.138
diff -u -3 -r1.138 pbx.c
--- pbx.c	17 Jul 2004 02:25:53 -0000	1.138
+++ pbx.c	18 Jul 2004 11:38:45 -0000
@@ -197,7 +197,7 @@
 
 	{ "BackGround", pbx_builtin_background,
 	"Play a file while awaiting extension",
-	"  Background(filename): Plays a given file, while simultaneously waiting for\n"
+	"  Background(filename[|options]): Plays a given file, while simultaneously waiting for\n"
 	"the user to begin typing an extension. The  timeouts do not count until the\n"
 	"last BackGround application has ended. Always returns 0.\n" 
 	},
@@ -4431,20 +4431,51 @@
 
 static int pbx_builtin_background(struct ast_channel *chan, void *data)
 {
-	int res;
+        int res = 0;
+        int option_skip = 0;
+        int option_noanswer = 0;
+        char filename[256] = "";
+        char* stringp;
+        char* options;
+
+        if (!data || ast_strlen_zero(data)) {
+                ast_log(LOG_WARNING, "Background requires an argument(filename)\n");
+                return -1;
+        }
+
+        strncpy(filename, (char*)data, sizeof(filename) - 1);
+        stringp = filename;
+        strsep(&stringp, "|");
+        options = strsep(&stringp, "|");
+
+        if (options && !strcasecmp(options, "skip"))
+                option_skip = 1;
+        if (options && !strcasecmp(options, "noanswer"))
+                option_noanswer = 1;
+
+        /* Answer if need be */
+        if (chan->_state != AST_STATE_UP) {
+                if (option_skip) {
+                        return 0;
+                } else if (!option_noanswer) {
+                        res = ast_answer(chan);
+                }
+        }
+
+        if (!res) {
+                /* Stop anything playing */
+                ast_stopstream(chan);
+                /* Stream a file */
+                res = ast_streamfile(chan, filename, chan->language);
+                if (!res) {
+                        res = ast_waitstream(chan, AST_DIGIT_ANY);
+                        ast_stopstream(chan);
+                } else {
+                        ast_log(LOG_WARNING, "ast_streamfile failed on %s fro %s\n", chan->name, (char*)data);
+                        res = 0;
+                }
+        }
 
-	/* Answer if need be */
-	if (chan->_state != AST_STATE_UP)
-		if (ast_answer(chan))
-			return -1;
-	/* Stop anything playing */
-	ast_stopstream(chan);
-	/* Stream a file */
-	res = ast_streamfile(chan, (char *)data, chan->language);
-	if (!res) {
-		res = ast_waitstream(chan, AST_DIGIT_ANY);
-		ast_stopstream(chan);
-	}
 	return res;
 }
 
